#ifndef COMBATANT_H
#define COMBATANT_H

#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_ttf.h"
#include <vector>
#include <string>
using namespace std;

#include "InputObj.h"
#include "MediaPlayer.h"

class Combatant {
 public:
  Combatant ();
  ~Combatant ();

  void processInput (const SDL_Event &);
  void setMedia (MediaPlayer *);
  void render (SDL_Surface * dest, TTF_Font * font);
  bool takeDamage (Uint32 &, Uint32, Uint32);

  InputObj * getIo ();
  void setInput (InputObj * i);

  MediaPlayer * getMediaPlayer ();

  void setSide (bool);
  bool getAreYouDead ();

  void animate (Uint32, Uint32, Combatant * = NULL, Uint32 = 0, Uint32 = 0);
  Uint32 numberOfPossibleAnims (Uint32);

  string getName ();
  void setName (string &);

  Uint32 getHp ();
  Uint32 getMaxHp ();
  void addMaxHP (Uint32);
  void setMaxHP (Uint32);
  void addHP (Uint32);

  Sint32 addAtkPoints (Sint32);
  void getAtkStats (Uint32 *, Sint32 *, Uint32 *);
  void loseAtkLevel (Uint8);
  void setAtkLevel (Uint8);
  Uint32 getAtkLevel ();

  Sint32 addDefPoints (Sint32);
  void getDefStats (Uint32 *, Sint32 *, Uint32 *);
  void loseDefLevel (Uint8);
  void setDefLevel (Uint8);
  Uint32 getDefLevel ();

  Sint32 addHealPoints (Sint32);
  void getHealStats (Uint32 *, Sint32 *, Uint32 *);
  Uint8 emptyHealLevels ();
  Uint32 getHealLevel ();

  void getSkillStats (Sint32 & curr, Uint32 & next, Uint32 & lvl, Uint32 index);
  Sint32 getCostOfLevel (Sint32, Uint8, Uint8, Uint8);

 protected:
  SDL_Surface * textOutput;

  string * name;
  Uint32 maxHp;
  Uint32 hp;
  bool playerSide;
  bool areYouDead;
  InputObj * io;
  MediaPlayer * mo;

  Sint32 atkCurrent;
  Uint32 atkLevel;
  Uint32 atkNext;

  Sint32 defCurrent;
  Uint32 defLevel;
  Uint32 defNext;

  Sint32 healCurrent;
  Uint32 healLevel;
  Uint32 healNext;

  Uint8 atkIncreaser;
  Uint8 atkStyle;
  Uint8 atkInitLvl;
  Uint8 atkInitToNext;

  Uint8 defIncreaser;
  Uint8 defStyle;
  Uint8 defInitLvl;
  Uint8 defInitToNext;

  Uint8 healIncreaser;
  Uint8 healStyle;
  Uint8 healInitLvl;
  Uint8 healInitToNext;
};
#endif
