#ifndef DRAWWINDOW_H
#define DRAWWINDOW_H

#include "SDL.h"
#include "SDL_gfxPrimitives.h"

#include "InputObj.h"
#include "LinePattern.h"
#include "Combatant.h"
#include "Enemy.h"

class DrawWindow {
 public:
  DrawWindow ();

  void setLinePattern (LinePattern *);
  void drawEvaluator (InputObj * io, Sint32 & end, Uint32 &, Uint8 &, Uint32, Uint32);
  int getDrawingStatus ();
  SDL_Rect getDimensions ();
  void evaluateRound (Uint32 &, Sint32 &, Uint8);
  void clear ();
  void render (SDL_Surface *, Uint8);
  void init (Combatant *, TTF_Font *, Enemy *, Uint32, Uint32);
  void setEnduranceLossRate (Uint32 e);
  Uint32 getEnduranceLossRate ();

  ~DrawWindow ();

 protected:
  LinePattern * lp;
  SDL_Rect dimensions;
  SDL_Rect * attStruct;
  Uint8 endBurn;
  Uint8 numHits;

  int drawingState;

  Uint32 lastTicks;
  Uint32 lastTicksDiscrete;
  Sint32 enduranceLost;

  Combatant * playerC;
  TTF_Font * font;

  Uint32 enduranceLossRate;
  double patternSizeMult;
  double patternDiff;
  Uint32 numExtraPatterns;
  Uint32 numExtraPts;

  Uint32 hitsDuringPattern;
};

#endif
