#ifndef ENEMY_H
#define ENEMY_H

#include "SDL.h"

#include "Combatant.h"
#include "MediaPlayer.h"
#include "MediaResource.h"

#include <vector>
#include <string>
using namespace std;

class Enemy {
 public:
  Enemy ();

  void setUpBadguy (Uint32);

  void getStatsForBadguy (Uint32, vector <string>, Uint32, double, double, double , double, double);

  void halvePatternSize ();

  double getPatternSizeMultiplier ();
  double getPatternDifficultyOffset ();
  Uint32 getEnduranceDrain ();

  Uint32 getEnemyIndex ();

  Combatant * getCombatant ();

  virtual ~Enemy ();

 protected:
  Combatant * c;
  MediaPlayer * mp;

  double patternSizeMultiplier;
  double patternDifficultyOffset;
  Uint32 enduranceDrain;
  Uint32 enemyTypeIndex;

  //should be a vector-based loader of some sort.
  vector <MediaResource *> mr;
};

#endif
