#include "InputObj.h"

#include "SDL.h"

InputObj :: InputObj ()
{
  accuracy = 10;
  posX = 0;
  posY = 0;

  lastTicks = SDL_GetTicks ();
  prevPosX.resize (0);
  prevPosY.resize (0);

  prevPosX.push_back (posX);
  prevPosY.push_back (posY);

  button1Pressed = false;
  button2Pressed = false;
  escKeyHit = false;
}

//handled by subclasses
void InputObj :: processInput (const SDL_Event & mainEvent)
{ }

void InputObj :: getCursorPos (Sint32 * x, Sint32 * y)
{
  //sets the x- and y- coordinates of the cursor.
  //unless the param is NULL, of course.
  
  if (x != NULL)
    *x = posX;

  if (y != NULL)
    *y = posY;
}

Sint32 InputObj :: getCursorPosX ()
{ return posX; }

Sint32 InputObj :: getCursorPosY ()
{ return posY; }

Sint32 InputObj :: getPreviousCursorPosX ()
{ return prevPosX.at(0); }

Sint32 InputObj :: getPreviousCursorPosY ()
{ return prevPosY.at(0); }

bool InputObj :: getButton1 ()
{ return button1Pressed; }

bool InputObj :: getButton2 ()
{ return button2Pressed; }

bool InputObj :: getEscKey ()
{ return escKeyHit; }

Uint32 InputObj :: getAccuracy ()
{
  return accuracy;
}

//handled by subclasses
void InputObj :: render (SDL_Surface * dest)
{}

void  InputObj :: clearInput ()
{
  button1Pressed = false;
  button2Pressed = false;
  escKeyHit = false;
}

InputObj :: ~InputObj ()
{
}
