#ifndef INPUTOBJ_H
#define INPUTOBJ_H

#include "SDL.h"
#include "SDL_gfxPrimitives.h"

#include <vector>
using namespace std;

class InputObj {
 public:
  InputObj ();

  virtual void processInput (const SDL_Event &);
  virtual void render (SDL_Surface * dest);

  virtual void clearInput ();

  void getCursorPos (Sint32 *, Sint32 *);
  Sint32 getCursorPosX ();
  Sint32 getCursorPosY ();
  Sint32 getPreviousCursorPosX ();
  Sint32 getPreviousCursorPosY ();
  Uint32 getAccuracy ();

  bool getButton1 ();
  bool getButton2 ();
  bool getEscKey ();

  virtual ~InputObj ();

 protected:
  Sint32 posX;
  Sint32 posY;

  Uint32 accuracy;
  bool button1Pressed;
  bool button2Pressed;
  bool escKeyHit;
  
  Uint32 lastTicks;
  vector <Sint32> prevPosX;
  vector <Sint32> prevPosY;
};

#endif
