#ifndef MEDIAPLAYER_H
#define MEDIAPLAYER_H

#include "SDL.h"
#include <vector>
#include <string>
using namespace std;

#include "MediaResource.h"

///holds animation and sound playing information specific to an object.

class MediaPlayer {
 public:
  MediaPlayer (MediaResource *);
  int render (SDL_Surface * dest, SDL_Rect & center);
  int changeAnim (Uint32, Uint32, MediaPlayer * = NULL, Uint32 = 0, Uint32 = 0);
  Uint32 numberOfPossibleAnims (Uint32);
  ~MediaPlayer ();
 protected:
  Uint32 animCatToPlay;
  Uint32 animSubToPlay;
  Uint32 animIndexToPlay;
  Uint32 channelToPlay;
  Uint32 startTime;
  Sint32 loopCounter;
  MediaResource * medRes;

  MediaPlayer * mpPartner;
  Uint32 partnerCategoryAnim;
  Uint32 partnerSubAnim;
  bool partnerAnimated;
};

#endif
