#ifndef MEDIARESOURCE_H
#define MEDIARESOURCE_H

#include "SDL.h"
#include <vector>
#include <string>
#include <iostream>
#include <fstream>
using namespace std;

#include "AnimFrame.h"

struct action {
  action ()
  { numLoops = -1; whatToDoWhenOutOfLoops = 0; }

  ~action ()
  {
    vector <AnimFrame *> :: iterator iter;
    iter = anim.begin ();

    while (iter < anim.end ())
      {
	delete (*iter);
	iter ++;
      }
  }

  vector <AnimFrame*> anim;
  //add audio info here
  //soundChunk sound to play

  Sint32 numLoops;
  Uint32 whatToDoWhenOutOfLoops;
};

class MediaResource {
 public:
  MediaResource (string);
  Sint32 drawPic (SDL_Surface *, SDL_Rect &, Uint32, Uint32, Uint32);
  Sint32 changePic (Uint32, Uint32 &, Uint32 &, Uint32 &, Sint32 &);
  Sint32 getLoops (Uint32, Uint32);
  bool getPartnerShouldAnimateNow (Uint32, Uint32, Uint32);
  Uint32 numberOfPossibleAnims (Uint32);
  action * getAction (Uint32, Uint32);

  virtual ~MediaResource ();
 protected:

  vector <vector <action *> > actionList;
  string name;
  ifstream infile;
};

#endif
