#include "StatRecord.h"
#include "SDL.h"

#include <iostream>
#include <ostream>
#include <sstream>
using namespace std;

StatRecord :: StatRecord ()
{
  clear ();
}

void StatRecord :: clear ()
{
  vector <FightRecord *> :: iterator iter;
  iter = records.begin ();
  while (iter < records.end ())
    {
       delete (*iter);
      iter ++;
    }
  records.resize (0);
  makingStat = false;
}

Sint32 StatRecord :: recordStats1 (Uint32 nWins, Uint32 enemIndex, Uint32 atkLvl, Uint32 defLvl, Sint32 atkComp, Sint32 defComp)
{
  //makes a new stat.
  //If makingStat is true, then the previous stat is assumed incomplete and is deleted. Returns 1 in that case.
  //Otherwise, sets makingStat to true and returns 0.
  //use recordStats2 to finish the stat off.

  if (makingStat)
    {
      delete (records.back ());
      records.erase (records.end ());
    }

  FightRecord * fr = new FightRecord ();

  fr -> numWins = nWins;
  fr -> hpAfterFight = 0;
  fr -> hpRegen = 0;
  fr -> enemyIndexForFight = enemIndex;
  fr -> numRounds = 0;
  fr -> yourAtkLevel = atkLvl;
  fr -> yourDefLevel = defLvl;
  fr -> atkCompare = atkComp;
  fr -> defCompare = defComp;
  
  records.push_back (fr);
  makingStat = true;

  return 0;
}

Sint32 StatRecord :: recordStats2 (Uint32 hp, Uint32 hpRegen, Uint32 rnds)
{
  //finishes off the stat made in recordStats1.
  //if makingStat is false, then this information has no incomplete record to finish. It is discarded and returns 1.
  //otherwise, sets makingStat to false and returns 0.
  //use recordStats 1 to make a new stat.

  if (!makingStat)
    return 1;

  FightRecord * fr = records.back ();

  fr -> hpAfterFight = hp;
  fr -> hpRegen = hpRegen;
  fr -> numRounds = rnds;
  
  makingStat = false;

  return 0;
}

Sint32 StatRecord :: coutStats (Sint32 index)
{
  //couts the stats of fight index.
  //If index is -1, prints out the last (most recent) fight.
  //If index is out of bounds, prints the most recent fight and returns 2.
  Sint32 ans = 0, indexToPrint = index;

  if (records.size () <= 0)
    return 1;

  if (index == -1)
    indexToPrint = records.size () - 1;
  else if (index < 0 || Uint32(index) >= records.size ())
    {ans = 1; indexToPrint = records.size () - 1;}

  FightRecord * fr = records.at (indexToPrint);

  cout << fr -> numWins << " " << fr -> hpAfterFight << " " << fr -> hpRegen << " " << fr -> enemyIndexForFight << " " << fr -> numRounds << " " << fr -> yourAtkLevel << " " << fr -> yourDefLevel << " " << fr -> atkCompare << " " << fr -> defCompare << endl;
  cout.flush ();

  return ans;
}

StatRecord :: ~StatRecord ()
{
  clear ();
}
