#include "UserInput.h"

#include "SDL.h"
#include "SDL_gfxPrimitives.h"

#include <iostream>
using namespace std;

UserInput :: UserInput () : InputObj ()
{
}

void UserInput :: processInput (const SDL_Event & mainEvent)
{
  //capture input

  switch(mainEvent.type){
  case SDL_MOUSEMOTION:
    prevPosX.push_back (posX);
    prevPosY.push_back (posY);

    //if enough time has elapsed, pop the last one.
    if (SDL_GetTicks () - lastTicks > 200)
      {prevPosX.erase (prevPosX.begin ());
      prevPosY.erase (prevPosY.begin ());}

    posX = mainEvent.motion.x;
    posY = mainEvent.motion.y;
    break;
  case SDL_MOUSEBUTTONDOWN:
    if (mainEvent.button.button == SDL_BUTTON_LEFT)
      button1Pressed = true;
    if (mainEvent.button.button == SDL_BUTTON_RIGHT)
      button2Pressed = true;
    break;
  case SDL_MOUSEBUTTONUP:
    if (mainEvent.button.button == SDL_BUTTON_LEFT)
      button1Pressed = false;
    if (mainEvent.button.button == SDL_BUTTON_RIGHT)
      button2Pressed = false;
  default:
    break;
  }
}

void UserInput :: forceMousePos ()
{
  int px, py;

  SDL_GetMouseState(&px, &py);

  lastTicks = SDL_GetTicks ();
  prevPosX.resize (0);
  prevPosY.resize (0);

  prevPosX.push_back (posX);
  prevPosY.push_back (posY);

  posX = Sint16(px);
  posY = Sint16(py);  
}

void UserInput :: render (SDL_Surface * dest)
{
  //filledCircleRGBA(dest, posX, posY, accuracy, 64, 64, 64, 128);
  //aa
  circleRGBA(dest, posX, posY, accuracy, 0, 0, 0, 255);
}

UserInput :: ~ UserInput ()
{
}
