#include "sdMath.h"
#include <math.h>
#include <stdlib.h>

#include "SDL.h"

#include <iostream>
using namespace std;

#define numPI 3.141590

void rectToPolar (double xDist, double yDist, double & radius, double & angle)
{
  angle = atan2 (yDist, xDist);
  radius = hypotCalc (xDist, yDist);
}

void polarToRect (double radius, double angle, double & xDist, double & yDist)
{
  xDist = radius * cos (angle);
  yDist = radius * sin (angle);
}

double hypotCalc (double xDist, double yDist)
{
  return sqrt ((xDist * xDist) + (yDist * yDist));
}

double restrictAnglePos (double a)
{
  //restricts the angle from 0 to 2.0 * numPI

  double ta = a;

  if (ta < 0.0)
    ta += 2.0 * numPI;

  if (ta > 2.0 * numPI)
    ta -= 2.0 * numPI;

  return ta;
}

double normalRandom (double s)
{
  /* normal random variate generator */
  /* mean m, standard deviation s */
  //assumes mean m

  // from http://www.taygeta.com/random/gaussian.html
  // Algorithm by Dr. Everett (Skip) Carter, Jr.

  float x1, x2, w, y1, y2;
 
  do {
    x1 = 2.0 * randomUniform() - 1.0;
    x2 = 2.0 * randomUniform() - 1.0;
    w = x1 * x1 + x2 * x2;
  } while ( w >= 1.0 );

  w = sqrt( (-2.0 * log( w ) ) / w );
  y1 = x1 * w;
  y2 = x2 * w;

  //return( m + y1 * s ); m = mean, s = standard deviation

  return( 0 + y1 * s );
}

Uint32 randomUniformInt (Uint32 max)
{
  return (rand () % max);
}

double randomUniform ()
{
  //returns random number from 0 to 1, randomly distributed.
  return (double (rand ()) / double (RAND_MAX));
}
